/*
  ==============================================================================

  This is an automatically generated GUI class created by the Introjucer!

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Created with Introjucer version: 3.2.0

  ------------------------------------------------------------------------------

  The Introjucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright (c) 2015 - ROLI Ltd.
  
	Tubbutec firmware updater
    Copyright (C) 2015 Tobias Münzer

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
//[/Headers]

#include "Gui.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...

//[/MiscUserDefs]

//==============================================================================
Gui::Gui():Thread("UpdateThread")
{
    //[Constructor_pre] You can add your own custom stuff here..
	midiInNew = false;

	addAndMakeVisible(fwCheckButton = new TextButton("versionButton"));
	fwCheckButton->setButtonText(TRANS("Check version"));
	fwCheckButton->setConnectedEdges(Button::ConnectedOnTop | Button::ConnectedOnBottom);
	fwCheckButton->setEnabled(false);
	fwCheckButton->addListener(this);
	
    //[/Constructor_pre]

    addAndMakeVisible (label = new Label ("new label",
                                          TRANS("(1) select product")));
    label->setFont (Font (15.00f, Font::plain));
    label->setJustificationType (Justification::centredLeft);
    label->setEditable (false, false, false);
    label->setColour (TextEditor::textColourId, Colours::black);
    label->setColour (TextEditor::backgroundColourId, Colour (0x00000000));

    addAndMakeVisible (loadButton = new TextButton ("loadButton"));
    loadButton->setButtonText (TRANS("Load"));
    loadButton->setConnectedEdges (Button::ConnectedOnTop | Button::ConnectedOnBottom);
    loadButton->addListener (this);

    addAndMakeVisible (comboBoxProduct = new ComboBox ("new combo box"));
    comboBoxProduct->setExplicitFocusOrder (1);
    comboBoxProduct->setEditableText (false);
    comboBoxProduct->setJustificationType (Justification::centredLeft);
    comboBoxProduct->setTextWhenNothingSelected (String::empty);
    comboBoxProduct->setTextWhenNoChoicesAvailable (TRANS("(no choices)"));
    comboBoxProduct->addItem (TRANS("SH-1oh1"), 1);
    comboBoxProduct->addItem (TRANS("Juno-66"), 2);
    comboBoxProduct->addItem (TRANS("ModyPoly"), 3);
	comboBoxProduct->addItem(TRANS("Modysix"), 4);
    comboBoxProduct->addItem (TRANS("UniTrigger"), 5);
	comboBoxProduct->setSelectedId(1);
    comboBoxProduct->addListener (this);

    addAndMakeVisible (label2 = new Label ("new label",
                                           TRANS("(2) select image file")));
    label2->setFont (Font (15.00f, Font::plain));
    label2->setJustificationType (Justification::centredLeft);
    label2->setEditable (false, false, false);
    label2->setColour (TextEditor::textColourId, Colours::black);
    label2->setColour (TextEditor::backgroundColourId, Colour (0x00000000));

    addAndMakeVisible (textEditorImage = new TextEditor ("new text editor"));
    textEditorImage->setMultiLine (false);
    textEditorImage->setReturnKeyStartsNewLine (false);
    textEditorImage->setReadOnly (true);
    textEditorImage->setScrollbarsShown (true);
    textEditorImage->setCaretVisible (false);
    textEditorImage->setPopupMenuEnabled (true);
    textEditorImage->setText (String::empty);

    addAndMakeVisible (label3 = new Label ("new label",
                                           TRANS("(3) select midi in")));
    label3->setFont (Font (15.00f, Font::plain));
    label3->setJustificationType (Justification::centredLeft);
    label3->setEditable (false, false, false);
    label3->setColour (TextEditor::textColourId, Colours::black);
    label3->setColour (TextEditor::backgroundColourId, Colour (0x00000000));

    addAndMakeVisible (label4 = new Label ("new label",
                                           TRANS("(4) select midi out")));
    label4->setFont (Font (15.00f, Font::plain));
    label4->setJustificationType (Justification::centredLeft);
    label4->setEditable (false, false, false);
    label4->setColour (TextEditor::textColourId, Colours::black);
    label4->setColour (TextEditor::backgroundColourId, Colour (0x00000000));

    addAndMakeVisible (comboBoxMidiIn = new ComboBox ("new combo box"));
    comboBoxMidiIn->setEditableText (false);
    comboBoxMidiIn->setJustificationType (Justification::centredLeft);
    comboBoxMidiIn->setTextWhenNothingSelected (String::empty);
    comboBoxMidiIn->setTextWhenNoChoicesAvailable (TRANS("(no choices)"));
    comboBoxMidiIn->addListener (this);

    addAndMakeVisible (comboBoxMidiOut = new ComboBox ("new combo box"));
    comboBoxMidiOut->setEditableText (false);
    comboBoxMidiOut->setJustificationType (Justification::centredLeft);
    comboBoxMidiOut->setTextWhenNothingSelected (String::empty);
    comboBoxMidiOut->setTextWhenNoChoicesAvailable (TRANS("(no choices)"));
    comboBoxMidiOut->addListener (this);

    addAndMakeVisible (updateButton = new TextButton ("updateButton"));
    updateButton->setButtonText (TRANS("(5) Update"));
    updateButton->setConnectedEdges (Button::ConnectedOnTop | Button::ConnectedOnBottom);
    updateButton->addListener (this);

    addAndMakeVisible (textEditorOutput = new TextEditor ("new text editor"));
    textEditorOutput->setMultiLine (true);
    textEditorOutput->setReturnKeyStartsNewLine (true);
    textEditorOutput->setReadOnly (true);
    textEditorOutput->setScrollbarsShown (true);
    textEditorOutput->setCaretVisible (false);
    textEditorOutput->setPopupMenuEnabled (true);
    textEditorOutput->setText (String::empty);

    //[UserPreSize]
	addAndMakeVisible(progBar = new ProgressBar(progress));
	progress = 0.0;
	//progBar->
    //[/UserPreSize]

    setSize (555, 340);


    //[Constructor] You can add your own custom stuff here..
	StringArray outputDevs = MidiOutput::getDevices();
	comboBoxMidiOut->addItemList(outputDevs,1);
	comboBoxMidiOut->setSelectedId(1);

	StringArray inputDevs = MidiInput::getDevices();
	comboBoxMidiIn->addItemList(inputDevs, 1);
	comboBoxMidiIn->setSelectedId(1);

	


    //[/Constructor]
}

Gui::~Gui()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    label = nullptr;
    loadButton = nullptr;
    comboBoxProduct = nullptr;
    label2 = nullptr;
    textEditorImage = nullptr;
    label3 = nullptr;
    label4 = nullptr;
    comboBoxMidiIn = nullptr;
    comboBoxMidiOut = nullptr;
    updateButton = nullptr;
    textEditorOutput = nullptr;
	progBar = nullptr;
	


    //[Destructor]. You can add your own custom destruction code here..
	//midiOut = nullptr;
	midiIn = nullptr;
	stopThread(3000);
	//if (midiIn!=nullptr)
	//	delete midiIn;
	
	
    //[/Destructor]
}

//==============================================================================
void Gui::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void Gui::resized()
{
    //[UserPreResize] Add your own custom resize code here..
	progBar->setBounds(24, 155, 512, 16);
	fwCheckButton->setBounds(448, 24, 88, 24);
    //[/UserPreResize]

    label->setBounds (16, 24, 150, 24);
    loadButton->setBounds (448, 56, 88, 24);
    comboBoxProduct->setBounds (192, 24, 240, 24);
    label2->setBounds (16, 56, 150, 24);
    textEditorImage->setBounds (192, 56, 240, 24);
    label3->setBounds (16, 88, 150, 24);
    label4->setBounds (16, 120, 150, 24);
    comboBoxMidiIn->setBounds (192, 88, 240, 24);
    comboBoxMidiOut->setBounds (192, 120, 240, 24);
    updateButton->setBounds (448, 88, 88, 56);
    textEditorOutput->setBounds (24, 184, 512, 135);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void Gui::run()
{
	//const MessageManagerLock lock(Thread::getCurrentThread());
	//if (lock.lockWasGained()) {
		openMidiInPort(0);
		updateFirmware();
		closeMidiInPort();
	//	}
}

void Gui::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == loadButton)
    {
		FileChooser chooser("Select firmware image",
			File::nonexistent,
			"*.bin");                                        
		if (chooser.browseForFileToOpen())                                   
		{
			File file(chooser.getResult());                                 
			String s = file.loadFileAsString();
			textEditorImage->setText(file.getFullPathName());
			textEditorOutput->setText(" ");
		}

    }
    else if (buttonThatWasClicked == updateButton)
    {
        //[UserButtonCode_updateButton] -- add your button handler code here..
		
		//updateFirmware();
		updateButton->setEnabled(false);
		
		startThread();
		
		updateButton->setEnabled(true);
		writeLine(" ");

        //[/UserButtonCode_updateButton]
    }
	else if (buttonThatWasClicked == fwCheckButton)
	{
		openMidiInPort(0);
		checkFirmwareVersion();
		closeMidiInPort();
	}

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}

void Gui::comboBoxChanged (ComboBox* comboBoxThatHasChanged)
{
    //[UsercomboBoxChanged_Pre]
    //[/UsercomboBoxChanged_Pre]

    if (comboBoxThatHasChanged == comboBoxProduct)
    {
        //[UserComboBoxCode_comboBoxProduct] -- add your combo box handling code here..
		if (comboBoxThatHasChanged->getText().compare("SH-1oh1"))
			fwCheckButton->setEnabled(false);
		else
			fwCheckButton->setEnabled(true);
        //[/UserComboBoxCode_comboBoxProduct]
    }
    else if (comboBoxThatHasChanged == comboBoxMidiIn)
    {
        //[UserComboBoxCode_comboBoxMidiIn] -- add your combo box handling code here..
        //[/UserComboBoxCode_comboBoxMidiIn]
    }
    else if (comboBoxThatHasChanged == comboBoxMidiOut)
    {
        //[UserComboBoxCode_comboBoxMidiOut] -- add your combo box handling code here..
        //[/UserComboBoxCode_comboBoxMidiOut]
    }

    //[UsercomboBoxChanged_Post]
    //[/UsercomboBoxChanged_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...

void Gui::handleIncomingMidiMessage(MidiInput *  source, const MidiMessage &  message)
{
	unsigned char* sysexData = (unsigned char*)message.getRawData();
	int sysexDatalen = message.getRawDataSize();

	if (sysexDatalen == 3)
	{
		if (sysexData[0] == 0xF0 && sysexData[2] == 0xF7)
		{
			vers = sysexData[1];
			midiInNew = true;
			if (sysexData[1] == 0x65)
				midiInAck = true;
			else
				midiInAck = false;
		}
	}


}

int Gui::openMidiInPort(int inport)
{
	int ind = comboBoxMidiIn->getSelectedItemIndex();
	midiIn = MidiInput::openDevice(ind, this);
	if (midiIn == nullptr)
		return ERROR;
	midiIn->start();
	return 0;
}
void Gui::closeMidiInPort()
{
	if (midiIn == nullptr)
		return;

	midiIn->stop();
	//midiIn->~MidiInput();
	midiIn = nullptr;
	//delete(midiIn);
}

int Gui::waitForAck(int timeout = 200)
{
	/*int ind = comboBoxMidiIn->getSelectedItemIndex();
	MidiInput * midiIn = MidiInput::openDevice(ind, this);
	if (midiIn == nullptr)
		return ERROR;
	midiIn->start();
	*/

	int ret = TIMEOUT;

	for (int i = 0; i < timeout; i++)
	{
		Thread::sleep(10);

		if (midiInNew)
		{
			midiInNew = false;
			if (midiInAck)
				ret = ACK;
			else
				ret = NACK;

			break;
		}

	}
	//midiIn->stop();
	//delete midiIn;
	return ret;

}

void Gui::updateFirmware()
{

	String path = textEditorImage->getText();
	if (path == "")
	{
		writeLine("Please load image file");
		return;
	}
	
	File f = File(path);
	ScopedPointer<FileInputStream> fi = f.createInputStream();
	if (!fi->openedOk())
	{
		writeLine("Error opening image file");
		return;
	}
	int64 fsize = f.getSize();
	int blockcount = fsize / PAGESIZE;
	int rest = PAGESIZE - (fsize % PAGESIZE);
	if (rest == PAGESIZE)
		rest = 0;
	debugOut("bytes to read" + fsize);
	debugOut("Full Blocks: " + blockcount);
	debugOut("Bytes to pad: " + rest);

	if (rest != 0)
		blockcount++;

	int buffsize = blockcount*PAGESIZE;

	if (buffsize > 16*1024)
	{
		debugOut("Image file too large");
		return;
	}

	MemoryBlock membuf;// = MemoryBlock(buffsize);
	//membuf.fillWith(0xFF);
	f.loadFileAsData(membuf);
	membuf.ensureSize(buffsize);

	//pad with 0xFF
	unsigned char * buff = (unsigned char*)membuf.getData();
	for (int i = fsize; i < buffsize; i++)
	{
		buff[i] = 0xFF;
	}
	
	writeLine("Image file sucessfully read");

	String s = " ";
	int OutInd = comboBoxMidiOut->getSelectedItemIndex();
	ScopedPointer<MidiOutput> midiOut = MidiOutput::openDevice(OutInd);
	if (midiOut == nullptr)
	{
		writeLine("Error opening midi out port");
		return;
	}	
	writeLine("Midi out opened successfully");
	
	if (waitForAck(1) == ERROR)
	{
		writeLine("Error opening midi in port");
		return;
	}
	writeLine("Midi in port opened succesfully");

	//testing for product
#define HELLO_LEN 6
	unsigned char hello[HELLO_LEN] = { 't', 't','e', 'c', 'm', 'p' };
	String tmp = comboBoxProduct->getItemText(comboBoxProduct->getSelectedItemIndex());
	if (!tmp.compare("Modysix"))
	{
		hello[5] = 's';
	}

	writeLine("Sending welcome message");
	
	MidiMessage msg = MidiMessage::createSysExMessage(hello, HELLO_LEN);
	midiOut->sendMessageNow(msg);
	int res = waitForAck();
	if (res == ACK)
		writeLine(" ..OK");
	else
	{
		writeLine("Timout...Check connection and try again");
		return;
	}

	////------------send init message
	//prepare message
	writeLine("Sending init");
	msg = MidiMessage::createSysExMessage(&blockcount, 1);
	midiOut->sendMessageNow(msg);
	res = waitForAck();
	if (res == ACK)
		writeLine(" ..OK");
	else
	{
		writeLine("Timout sending init..faulty connection?");
		return;
	}

	/////////////////////////////////////////////////////////////////

	unsigned char blockmsg[PAGESIZE * 2 + 1];

	//Send blocks
	int bufindex = 0;
	int nackcounter = 0;
	for (int c = 0; c < blockcount; c++)
	{
		if (nackcounter >4)
		{
			writeLine("NACK timeout. Please check connections and midi interface and try again\nYou need to restart the synth before retrying\nAlso: read the manual section ");
			return;
		}

		unsigned char crc = 123;
		String str = " > Sending block ";
		str += c;
		writeLine(str);
		
		for (int i = 0; i<PAGESIZE; i++)
		{
			unsigned char b = buff[bufindex];
			bufindex++;

			crc += b;
			blockmsg[2 * i] = (unsigned char)(b & 0x0F);
			blockmsg[2 * i + 1] = (unsigned char)((b >> 4) & 0x0F);
		}

		//append checksum
		blockmsg[PAGESIZE * 2] = (unsigned char)(crc & 0x7F);
		//prepare message
		msg = MidiMessage::createSysExMessage(blockmsg, PAGESIZE * 2 + 1);
		//Deliver message
		midiOut->sendMessageNow(msg);

		writeLine(" ..wait for ACK");

		res = waitForAck();
		if (res == ACK)
			writeLine(" ..OK");
		else if (res == NACK)
		{
			writeLine(" ..NACK....retry");
			nackcounter++;
			c--;
			bufindex -= PAGESIZE;
		}
		else
		{	
			if (c != blockcount - 1)//hack, why nessesary?
			{
				writeLine("Timout ..faulty connection?");
				return;
			}
			
		}

		progress = (double)c / double(blockcount);
	}
	writeLine("");
	writeLine("All blocks sent - Firmware updated - have fun!");
	progress = 0.999999999;


	//////////////////////////////////////////////////////////////////
}

void Gui::writeLine(String line)
{
	const MessageManagerLock lock(Thread::getCurrentThread());
	if (lock.lockWasGained()) {
	textEditorOutput->setText(textEditorOutput->getText() + line + "\r");
	textEditorOutput->scrollDown();
	textEditorOutput->moveCaretToEnd();
		}
	
	//textEditorOutput->set
}

void Gui::debugOut(String line)
{
	//writeLine(line);
}

String Gui::getStringFromAck(int a)
{
	switch (a)
	{
		case ACK: return "OK";
		case NACK: return "negative response, trying again";
		case TIMEOUT: return "timeout..";
		default: return "error opening device";
	}
}

void Gui::checkFirmwareVersion()
{
	int OutInd = comboBoxMidiOut->getSelectedItemIndex();
	ScopedPointer<MidiOutput> midiOut = MidiOutput::openDevice(OutInd);
	if (midiOut == nullptr)
	{
		writeLine("Error opening midi out port");
		return;
	}
	writeLine("Midi out opened successfully");
	writeLine("Checking firmware version and connection");

	//testing for product
#define CHECK_LEN 3
	unsigned char check_str[CHECK_LEN] = { 't', 't', 'g'};

	MidiMessage msg = MidiMessage::createSysExMessage(check_str, CHECK_LEN);
	midiOut->sendMessageNow(msg);
	int res = waitForAck();
	if (res == NACK)
	{
		String s = "Firmware version: 1.";
		vers -= 16;
		if (vers < 10)
			s += "0";
		s += vers;
		writeLine(s);
	}
	else if (res == TIMEOUT)
	{
		writeLine("Tineout");
	}
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Introjucer information section --

    This is where the Introjucer stores the metadata that describe this GUI layout, so
    make changes in here at your peril!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="Gui" componentName="" parentClasses="public Component"
                 constructorParams="" variableInitialisers="" snapPixels="8" snapActive="1"
                 snapShown="1" overlayOpacity="0.330" fixedSize="0" initialWidth="600"
                 initialHeight="400">
  <BACKGROUND backgroundColour="ffffffff"/>
  <LABEL name="new label" id="bd0916c8ade5561a" memberName="label" virtualName=""
         explicitFocusOrder="0" pos="16 24 150 24" edTextCol="ff000000"
         edBkgCol="0" labelText="(1) select product" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTBUTTON name="loadButton" id="24ad507e75c31b7e" memberName="loadButton"
              virtualName="" explicitFocusOrder="0" pos="448 56 88 24" buttonText="Load"
              connectedEdges="12" needsCallback="1" radioGroupId="0"/>
  <COMBOBOX name="new combo box" id="34926fdae2452c4b" memberName="comboBoxProduct"
            virtualName="" explicitFocusOrder="1" pos="192 24 240 24" editable="0"
            layout="33" items="SH-1oh1&#10;Juno-66&#10;ModyPoly&#10;UniTrigger"
            textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="1919d71dc7da1805" memberName="label2" virtualName=""
         explicitFocusOrder="0" pos="16 56 150 24" edTextCol="ff000000"
         edBkgCol="0" labelText="(2) select image file" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="new text editor" id="ba3cad00d715f11b" memberName="textEditorImage"
              virtualName="" explicitFocusOrder="0" pos="192 56 240 24" initialText=""
              multiline="0" retKeyStartsLine="0" readonly="1" scrollbars="1"
              caret="0" popupmenu="1"/>
  <LABEL name="new label" id="57cd6c8537b0f2c5" memberName="label3" virtualName=""
         explicitFocusOrder="0" pos="16 88 150 24" edTextCol="ff000000"
         edBkgCol="0" labelText="(3) select midi in" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <LABEL name="new label" id="80ec77a110f79f81" memberName="label4" virtualName=""
         explicitFocusOrder="0" pos="16 120 150 24" edTextCol="ff000000"
         edBkgCol="0" labelText="(4) select midi out" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="9093a7f912165021" memberName="comboBoxMidiIn"
            virtualName="" explicitFocusOrder="0" pos="192 88 240 24" editable="0"
            layout="33" items="" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <COMBOBOX name="new combo box" id="462069ea4ff0cd8b" memberName="comboBoxMidiOut"
            virtualName="" explicitFocusOrder="0" pos="192 120 240 24" editable="0"
            layout="33" items="" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <TEXTBUTTON name="updateButton" id="bad3c66ce5c147fc" memberName="updateButton"
              virtualName="" explicitFocusOrder="0" pos="448 88 88 56" buttonText="(5) Update"
              connectedEdges="12" needsCallback="1" radioGroupId="0"/>
  <TEXTEDITOR name="new text editor" id="75ea719646e2f2f2" memberName="textEditorOutput"
              virtualName="" explicitFocusOrder="0" pos="24 184 512 120" initialText=""
              multiline="1" retKeyStartsLine="1" readonly="1" scrollbars="1"
              caret="0" popupmenu="1"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif


//[EndFile] You can add extra defines here...
//[/EndFile]
