/*
  ==============================================================================

  This is an automatically generated GUI class created by the Introjucer!

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Created with Introjucer version: 3.2.0

  ------------------------------------------------------------------------------

  The Introjucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright (c) 2015 - ROLI Ltd.
  
  Tubbutec firmware updater
    Copyright (C) 2015 Tobias Münzer

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  ==============================================================================
*/

#ifndef __JUCE_HEADER_1B7D314A9B5D26__
#define __JUCE_HEADER_1B7D314A9B5D26__

//[Headers]     -- You can add your own extra header files here --
#include "JuceHeader.h"
//[/Headers]



//==============================================================================
/**
                                                                    //[Comments]
    An auto-generated component, created by the Introjucer.

    Describe your class and how it works here!
                                                                    //[/Comments]
*/
class Gui  : public Component,
             public ButtonListener,
             public ComboBoxListener,
			 public MidiInputCallback,
			 public Thread
{
public:
    //==============================================================================
    Gui ();
    ~Gui();

    //==============================================================================
    //[UserMethods]     -- You can add your own custom methods in this section.
    //[/UserMethods]

    void paint (Graphics& g);
    void resized();
    void buttonClicked (Button* buttonThatWasClicked);
    void comboBoxChanged (ComboBox* comboBoxThatHasChanged);
	void handleIncomingMidiMessage(MidiInput * source,const MidiMessage & message);
	void run();



private:
    //[UserVariables]   -- You can add your own custom variables in this section.

	enum
	{
		ACK,
		NACK,
		TIMEOUT,
		ERROR
	};
	  
	bool midiInNew, midiInAck;
	unsigned char vers;

	int waitForAck(int timeout);
	void updateFirmware(void);
	void writeLine(String line);
	void debugOut(String line);
	String getStringFromAck(int a);
	void checkFirmwareVersion();
	int openMidiInPort(int inport);
	void closeMidiInPort();

#define PAGESIZE 128
	
	ScopedPointer<ProgressBar> progBar;
	ScopedPointer<TextButton> fwCheckButton;
	ScopedPointer<MidiInput>  midiIn;

	double progress;

    //[/UserVariables]

    //==============================================================================
    ScopedPointer<Label> label;
    ScopedPointer<TextButton> loadButton;
    ScopedPointer<ComboBox> comboBoxProduct;
    ScopedPointer<Label> label2;
    ScopedPointer<TextEditor> textEditorImage;
    ScopedPointer<Label> label3;
    ScopedPointer<Label> label4;
    ScopedPointer<ComboBox> comboBoxMidiIn;
    ScopedPointer<ComboBox> comboBoxMidiOut;
    ScopedPointer<TextButton> updateButton;
    ScopedPointer<TextEditor> textEditorOutput;
	

    //==============================================================================
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (Gui)
};

//[EndFile] You can add extra defines here...
//[/EndFile]

#endif   // __JUCE_HEADER_1B7D314A9B5D26__
